diff --git a/lib/hive/daemon/auto_retry_probe.rb b/lib/hive/daemon/auto_retry_probe.rb
new file mode 100644
index 00000000..6dba97fb
--- /dev/null
+++ b/lib/hive/daemon/auto_retry_probe.rb
@@ -0,0 +1,407 @@
+require "digest"
+require "json"
+require "stringio"
+require "tmpdir"
+require "timeout"
+require "time"
+require "hive"
+require "hive/agent_profiles"
+require "hive/claude_launcher"
+require "hive/commands/doctor"
+require "hive/daemon/bounded_command"
+require "hive/invoked_binary"
+require "hive/secret_patterns"
+
+module Hive
+  module Daemon
+    # Bounded dependency probes used only after exact classification and work
+    # safety pass. Every result is redacted and output-capped before it leaves
+    # this class.
+    class AutoRetryProbe
+      MAX_CAPTURE_BYTES = 4096
+      DOCTOR_TIMEOUT_SEC = 10
+      SHORT_TIMEOUT_SEC = 10
+      CODEX_SMOKE_TIMEOUT_SEC = 30
+
+      ProbeResult = Struct.new(
+        :name, :healthy, :exit_status, :timed_out, :duration_ms,
+        :stdout, :stderr, :rationale,
+        keyword_init: true
+      ) do
+        def to_h
+          {
+            "name" => name,
+            "healthy" => healthy,
+            "exit_status" => exit_status,
+            "timed_out" => timed_out,
+            "duration_ms" => duration_ms,
+            "stdout" => stdout,
+            "stderr" => stderr,
+            "rationale" => rationale
+          }
+        end
+      end
+
+      Aggregate = Struct.new(
+        :reason, :healthy, :probes, :fingerprint, :cheap_fingerprint,
+        keyword_init: true
+      )
+
+      def initialize(config:, project_root:, hive_bin: nil, env: ENV,
+                     command_runner: nil, doctor_factory: nil)
+        @config = config
+        @project_root = project_root
+        @env = env.to_h
+        @hive_bin = hive_bin || Hive::InvokedBinary.path(env: env) || "hive"
+        @command_runner = command_runner || method(:run_command)
+        @doctor_factory = doctor_factory || lambda {
+          Hive::Commands::Doctor.new(
+            config: @config, project_root: @project_root, output: StringIO.new
+          )
+        }
+      end
+
+      def call(reason:)
+        probes = [ doctor_probe ]
+        probes.concat(reason == "implementer_failed" ? codex_probes : claude_probes)
+        probes = probes.map { |probe| sanitize_probe(probe) }
+        cheap = safe_cheap_fingerprint(reason: reason)
+        fingerprint = health_fingerprint(reason: reason, probes: probes, cheap: cheap)
+        Aggregate.new(
+          reason: reason,
+          healthy: probes.all?(&:healthy),
+          probes: probes,
+          fingerprint: fingerprint,
+          cheap_fingerprint: cheap
+        )
+      rescue StandardError => e
+        failure = local_result(
+          "probe_aggregate", false, "probe aggregate raised #{e.class}: #{e.message}"
+        )
+        cheap = safe_cheap_fingerprint(reason: reason)
+        Aggregate.new(
+          reason: reason, healthy: false, probes: [ failure ],
+          fingerprint: health_fingerprint(reason: reason, probes: [ failure ], cheap: cheap),
+          cheap_fingerprint: cheap
+        )
+      end
+
+      def cheap_fingerprint(reason:)
+        signals = {
+          "reason" => reason.to_s,
+          "config_digest" => ::Digest::SHA256.hexdigest(
+            JSON.generate(relevant_config(reason))
+          ),
+          "environment_selection" => environment_selection(reason),
+          "required_skills" => required_skill_signal,
+        }
+        signals.merge!(reason_specific_signals(reason))
+        ::Digest::SHA256.hexdigest(JSON.generate(signals))
+      end
+
+      private
+
+      def doctor_probe
+        outcome = required_checks_outcome
+        if outcome[:error]
+          rationale = outcome[:timed_out] ? "required doctor timed out" :
+            "required doctor raised #{outcome[:error].class}: #{outcome[:error].message}"
+          return local_result(
+            "required_doctor", false, rationale,
+            timed_out: outcome[:timed_out], started: outcome[:started]
+          )
+        end
+
+        result = outcome.fetch(:result)
+        healthy = result[:healthy] == true
+        local_result(
+          "required_doctor", healthy,
+          healthy ? "required agents and skills are present" : result[:error] || "required agent or skill is missing",
+          stdout: JSON.generate(Array(result[:rows])),
+          started: outcome[:started]
+        )
+      end
+
+      def codex_probes
+        profile = Hive::AgentProfiles.lookup(:codex, cfg: @config)
+        login = @command_runner.call(
+          name: "codex_login_status",
+          argv: [ profile_binary(profile), "login", "status" ],
+          env: @env,
+          chdir: @project_root,
+          timeout_sec: SHORT_TIMEOUT_SEC
+        )
+        smoke = Dir.mktmpdir("hive-auto-retry-codex-") do |dir|
+          @command_runner.call(
+            name: "codex_exec_smoke",
+            argv: [
+              profile_binary(profile), "exec",
+              "--sandbox", "read-only",
+              "--skip-git-repo-check",
+              "--ephemeral",
+              "--ignore-rules",
+              "-c", "shell_environment_policy.inherit=none",
+              "--json", "Respond with exactly OK. Do not read or write files."
+            ],
+            env: @env,
+            chdir: dir,
+            timeout_sec: CODEX_SMOKE_TIMEOUT_SEC
+          )
+        end
+        [ login, smoke ]
+      rescue StandardError => e
+        [ local_result("codex_probe_setup", false, "Codex probe setup failed: #{e.class}: #{e.message}") ]
+      end
+
+      def claude_probes
+        [
+          wrapper_probe,
+          readiness_probe,
+          hive_identity_probe,
+          claude_binary_probe
+        ]
+      end
+
+      def wrapper_probe
+        path = Hive::ClaudeLauncher.interactive_wrapper_path
+        healthy = File.file?(path) && File.executable?(path)
+        local_result(
+          "claude_wrapper", healthy,
+          healthy ? "packaged Claude wrapper is executable" : "packaged Claude wrapper is missing or not executable"
+        )
+      rescue SystemCallError => e
+        local_result("claude_wrapper", false, "wrapper check failed: #{e.class}: #{e.message}")
+      end
+
+      def readiness_probe
+        healthy = Hive::ClaudeLauncher.readiness_self_check
+        local_result(
+          "claude_readiness_detector", healthy,
+          healthy ? "readiness detector accepted and rejected its canaries" : "readiness detector self-check failed"
+        )
+      end
+
+      def hive_identity_probe
+        result = @command_runner.call(
+          name: "hive_install_identity",
+          argv: [ @hive_bin, "--install-fingerprint" ],
+          env: @env,
+          chdir: @project_root,
+          timeout_sec: SHORT_TIMEOUT_SEC
+        )
+        return result unless result.healthy
+
+        external = JSON.parse(result.stdout)
+        loaded = Hive::InvokedBinary.loaded_identity
+        matched = !loaded["fingerprint"].to_s.empty? &&
+                  external["fingerprint"].to_s == loaded["fingerprint"].to_s &&
+                  external["version"].to_s == Hive::VERSION
+        result.healthy = matched
+        result.rationale = matched ? "daemon and CLI installation identities match" :
+          "daemon and CLI installation identities differ"
+        result
+      rescue JSON::ParserError => e
+        local_result("hive_install_identity", false, "invalid CLI identity JSON: #{e.message}")
+      end
+
+      def claude_binary_probe
+        profile = Hive::AgentProfiles.lookup(:claude, cfg: @config)
+        @command_runner.call(
+          name: "claude_binary",
+          argv: [ profile_binary(profile), profile.version_flag ],
+          env: @env,
+          chdir: @project_root,
+          timeout_sec: SHORT_TIMEOUT_SEC
+        )
+      rescue StandardError => e
+        local_result("claude_binary", false, "Claude profile failed: #{e.class}: #{e.message}")
+      end
+
+      def run_command(name:, argv:, env:, chdir:, timeout_sec:)
+        started = monotonic
+        command = Hive::Daemon::BoundedCommand.capture(
+          env: env, argv: argv, chdir: chdir,
+          timeout_sec: timeout_sec, max_bytes: MAX_CAPTURE_BYTES
+        )
+        status = command.status
+        success = !command.timed_out && status&.success?
+        result(
+          name: name, healthy: success, exit_status: status&.exitstatus,
+          timed_out: command.timed_out, started: started,
+          stdout: command.stdout, stderr: command.stderr,
+          rationale: command.timed_out ? "command timed out after #{timeout_sec}s" :
+            (success ? "command succeeded" : "command exited #{status&.exitstatus}")
+        )
+      rescue SystemCallError, IOError => e
+        result(name: name, healthy: false, started: started, stdout: "", stderr: "",
+               rationale: "command failed to start: #{e.class}: #{e.message}")
+      end
+
+      def local_result(name, healthy, rationale, stdout: "", timed_out: false, started: monotonic)
+        result(
+          name: name, healthy: healthy, timed_out: timed_out, started: started,
+          stdout: stdout, stderr: "", rationale: rationale
+        )
+      end
+
+      def result(name:, healthy:, rationale:, started:, stdout: "", stderr: "",
+                 exit_status: nil, timed_out: false)
+        ProbeResult.new(
+          name: name,
+          healthy: healthy,
+          exit_status: exit_status,
+          timed_out: timed_out,
+          duration_ms: ((monotonic - started) * 1000).round,
+          stdout: sanitize_output(stdout),
+          stderr: sanitize_output(stderr),
+          rationale: sanitize_output(rationale)
+        )
+      end
+
+      def sanitize_output(text)
+        redacted = Hive::SecretPatterns.redact(text.to_s)
+        redacted.byteslice(0, MAX_CAPTURE_BYTES).to_s.scrub
+      end
+
+      def sanitize_probe(probe)
+        ProbeResult.new(
+          name: probe.name.to_s,
+          healthy: probe.healthy == true,
+          exit_status: probe.exit_status,
+          timed_out: probe.timed_out == true,
+          duration_ms: probe.duration_ms.to_i,
+          stdout: sanitize_output(probe.stdout),
+          stderr: sanitize_output(probe.stderr),
+          rationale: sanitize_output(probe.rationale)
+        )
+      end
+
+      def health_fingerprint(reason:, probes:, cheap:)
+        normalized = probes.map do |probe|
+          {
+            "name" => probe.name,
+            "healthy" => probe.healthy,
+            "exit_status" => probe.exit_status,
+            "timed_out" => probe.timed_out
+          }
+        end
+        ::Digest::SHA256.hexdigest(JSON.generate([ reason.to_s, cheap, normalized ]))
+      end
+
+      def required_skill_signal
+        outcome = required_checks_outcome
+        return [ "error", outcome[:error].class.name, outcome[:timed_out] ] if outcome[:error]
+
+        result = outcome.fetch(:result)
+        {
+          "healthy" => result[:healthy] == true,
+          "error" => result[:error].to_s,
+          "rows" => Array(result[:rows])
+        }
+      end
+
+      def required_checks_outcome
+        @required_checks_outcome ||= begin
+          started = monotonic
+          result = Timeout.timeout(DOCTOR_TIMEOUT_SEC) do
+            @doctor_factory.call.required_checks
+          end
+          { result: result, started: started, timed_out: false }
+        rescue Timeout::Error => e
+          { error: e, started: started, timed_out: true }
+        rescue StandardError => e
+          { error: e, started: started, timed_out: false }
+        end
+      end
+
+      def relevant_config(reason)
+        common = {
+          "brainstorm" => @config["brainstorm"],
+          "plan" => @config["plan"],
+          "reviewers" => @config.dig("review", "reviewers")
+        }
+        if reason.to_s == "implementer_failed"
+          common.merge(
+            "agent" => @config.dig("agents", "codex"),
+            "execute" => @config["execute"]
+          )
+        else
+          common.merge(
+            "agent" => @config.dig("agents", "claude"),
+            "claude" => @config["claude"]
+          )
+        end
+      end
+
+      def environment_selection(reason)
+        keys = if reason.to_s == "implementer_failed"
+          %w[HIVE_CODEX_BIN PATH]
+        else
+          %w[HIVE_CLAUDE_BIN HIVE_INVOKED_BIN PATH]
+        end
+        keys.to_h do |key|
+          [ key, ::Digest::SHA256.hexdigest(@env[key].to_s) ]
+        end
+      end
+
+      def reason_specific_signals(reason)
+        if reason.to_s == "implementer_failed"
+          {
+            "codex_binary" => binary_signal(:codex)
+          }
+        else
+          {
+            "hive_identity" => Hive::InvokedBinary.loaded_identity["fingerprint"],
+            "claude_binary" => binary_signal(:claude),
+            "wrapper" => wrapper_signal
+          }
+        end
+      end
+
+      def binary_signal(name)
+        profile = Hive::AgentProfiles.lookup(name, cfg: @config)
+        path = resolve_binary(profile_binary(profile))
+        stat = File.stat(path)
+        [ path, stat.size, stat.mtime.to_i ]
+      rescue StandardError
+        [ name.to_s, "unresolved" ]
+      end
+
+      def wrapper_signal
+        path = Hive::ClaudeLauncher.interactive_wrapper_path
+        stat = File.stat(path)
+        [ path, stat.size, stat.mtime.to_i, ::Digest::SHA256.file(path).hexdigest ]
+      rescue StandardError
+        [ "wrapper", "unresolved" ]
+      end
+
+      def resolve_binary(binary)
+        return File.realpath(binary) if binary.include?(File::SEPARATOR)
+
+        @env["PATH"].to_s.split(File::PATH_SEPARATOR).each do |dir|
+          candidate = File.join(dir, binary)
+          return File.realpath(candidate) if File.file?(candidate) && File.executable?(candidate)
+        end
+        binary
+      end
+
+      def profile_binary(profile)
+        key = profile.env_bin_override_key
+        override = key && @env[key].to_s
+        override && !override.empty? ? override : profile.bin_default
+      end
+
+      def safe_cheap_fingerprint(reason:)
+        cheap_fingerprint(reason: reason)
+      rescue StandardError => e
+        ::Digest::SHA256.hexdigest(
+          JSON.generate([ reason.to_s, "cheap_fingerprint_error", e.class.name ])
+        )
+      end
+
+      def monotonic
+        Process.clock_gettime(Process::CLOCK_MONOTONIC)
+      end
+    end
+  end
+end
diff --git a/lib/hive/daemon/bounded_command.rb b/lib/hive/daemon/bounded_command.rb
new file mode 100644
index 00000000..621c307a
--- /dev/null
+++ b/lib/hive/daemon/bounded_command.rb
@@ -0,0 +1,141 @@
+module Hive
+  module Daemon
+    # Captures a subprocess through continuously-drained pipes. Only the first
+    # max_bytes per stream are retained; later bytes are discarded while the
+    # child runs, so a noisy or timed-out command cannot consume unbounded
+    # temporary storage. Readers are closed after the leader exits so a
+    # detached descendant that inherited stdout/stderr cannot hold capture open.
+    module BoundedCommand
+      Result = Struct.new(:stdout, :stderr, :status, :timed_out, keyword_init: true)
+      TERMINATE_GRACE_SEC = 1
+      POLL_SEC = 0.01
+      READER_JOIN_SEC = 0.1
+      READ_CHUNK_BYTES = 16 * 1024
+
+      module_function
+
+      def capture(env:, argv:, chdir:, timeout_sec:, max_bytes:)
+        stdout_reader, stdout_writer = IO.pipe
+        stderr_reader, stderr_writer = IO.pipe
+        stdout = +""
+        stderr = +""
+        readers = [ stdout_reader, stderr_reader ]
+        threads = [
+          capture_stream(stdout_reader, stdout, max_bytes),
+          capture_stream(stderr_reader, stderr, max_bytes)
+        ]
+
+        pid = Process.spawn(
+          env, *argv,
+          chdir: chdir, pgroup: true, in: File::NULL,
+          out: stdout_writer, err: stderr_writer
+        )
+        stdout_writer.close
+        stderr_writer.close
+        status, timed_out = wait_with_deadline(pid, timeout_sec)
+        finish_capture(readers, threads)
+        Result.new(
+          stdout: stdout,
+          stderr: stderr,
+          status: status,
+          timed_out: timed_out
+        )
+      ensure
+        [ stdout_writer, stderr_writer, stdout_reader, stderr_reader ].compact.each do |io|
+          io.close unless io.closed?
+        rescue IOError
+          nil
+        end
+        Array(threads).each do |thread|
+          next unless thread&.alive?
+
+          thread.kill
+          thread.join
+        end
+      end
+
+      def wait_with_deadline(pid, timeout_sec)
+        deadline = monotonic + timeout_sec.to_f
+        loop do
+          waited, status = Process.waitpid2(pid, Process::WNOHANG)
+          return [ status, false ] if waited
+          break if monotonic >= deadline
+
+          sleep POLL_SEC
+        end
+
+        [ terminate_group(pid), true ]
+      end
+
+      def terminate_group(pid)
+        begin
+          Process.kill("TERM", -pid)
+        rescue Errno::ESRCH
+          return reap(pid)
+        end
+        deadline = monotonic + TERMINATE_GRACE_SEC
+        loop do
+          waited, status = Process.waitpid2(pid, Process::WNOHANG)
+          return status if waited
+          break if monotonic >= deadline
+
+          sleep POLL_SEC
+        end
+        begin
+          Process.kill("KILL", -pid)
+        rescue Errno::ESRCH
+          nil
+        end
+        reap(pid)
+      rescue Errno::ECHILD
+        nil
+      end
+
+      def reap(pid)
+        _waited, status = Process.waitpid2(pid)
+        status
+      rescue Errno::ECHILD
+        nil
+      end
+
+      def capture_stream(io, buffer, max_bytes)
+        limit = [ max_bytes.to_i, 0 ].max
+        Thread.new do
+          loop do
+            chunk = io.readpartial(READ_CHUNK_BYTES)
+            remaining = limit - buffer.bytesize
+            buffer << chunk.byteslice(0, remaining) if remaining.positive?
+          end
+        rescue EOFError, IOError
+          nil
+        ensure
+          io.close unless io.closed?
+        end.tap { |thread| thread.report_on_exception = false }
+      end
+
+      def finish_capture(readers, threads)
+        deadline = monotonic + READER_JOIN_SEC
+        threads.each do |thread|
+          remaining = deadline - monotonic
+          thread.join(remaining) if remaining.positive?
+        end
+        readers.each do |reader|
+          reader.close unless reader.closed?
+        rescue IOError
+          nil
+        end
+        threads.each do |thread|
+          thread.join(POLL_SEC)
+          next unless thread.alive?
+
+          thread.kill
+          thread.join
+        end
+      end
+
+      def monotonic
+        Process.clock_gettime(Process::CLOCK_MONOTONIC)
+      end
+    end
+  end
+end
diff --git a/lib/hive/daemon/dispatch_request_queue.rb b/lib/hive/daemon/dispatch_request_queue.rb
index 00d7aacc..47d89c9f 100644
--- a/lib/hive/daemon/dispatch_request_queue.rb
+++ b/lib/hive/daemon/dispatch_request_queue.rb
@@ -13,7 +13,7 @@ module Hive
       module_function
 
       SCHEMA = "hive-dispatch-request".freeze
-      SCHEMA_VERSION = 2
+      SCHEMA_VERSION = 3
 
       ALLOWED_VERBS = %w[
         run develop brainstorm plan review open-pr artifacts finalize
@@ -27,10 +27,11 @@ module Hive
 
       SLUG_RE = /\A[a-z][a-z0-9-]{0,62}[a-z0-9]\z/
       PROJECT_RE = /\A[A-Za-z0-9_.\-]+\z/
+      MARKER_ID_RE = /\A[A-Za-z0-9._\-]+\z/
 
       Request = Struct.new(
         :request_id, :created_at, :project, :slug, :argv, :requestor,
-        :chat_id, :update_id, :trigger, :path,
+        :chat_id, :update_id, :trigger, :expected_cleared_marker_id, :path,
         keyword_init: true
       )
 
@@ -50,12 +51,19 @@ module Hive
 
       def write_request!(project:, slug:, argv:, requestor: "bot", chat_id: nil,
                          update_id: nil, trigger: nil, request_id: generate_request_id,
+                         expected_cleared_marker_id: nil,
                          state_home: Hive::Paths.state_home, now: Time.now)
         unless valid_argv?(argv)
           raise ArgumentError, "argv #{argv.inspect} is not allowlisted for dispatch requests"
         end
         raise ArgumentError, "project is required for dispatch requests" if project.to_s.empty?
         raise ArgumentError, "slug is required for dispatch requests" if slug.to_s.empty?
+        if !expected_cleared_marker_id.nil? &&
+           (!expected_cleared_marker_id.is_a?(String) ||
+            !MARKER_ID_RE.match?(expected_cleared_marker_id) ||
+            expected_cleared_marker_id.to_s.bytesize > 128)
+          raise ArgumentError, "expected_cleared_marker_id is invalid"
+        end
 
         created_at = now.utc
         payload = {
@@ -71,6 +79,9 @@ module Hive
           "update_id" => update_id,
           "trigger" => trigger.to_s
         }
+        unless expected_cleared_marker_id.nil?
+          payload["expected_cleared_marker_id"] = expected_cleared_marker_id.to_s
+        end
 
         dir = directory(state_home: state_home)
         filename = filename_for(created_at: created_at, request_id: request_id)
@@ -360,6 +371,10 @@ module Hive
       end
 
       def expired?(request, now: Time.now, expiry_sec: EXPIRY_SEC)
+        if request.respond_to?(:expected_cleared_marker_id) &&
+           !request.expected_cleared_marker_id.to_s.empty?
+          return false
+        end
         return false unless request.respond_to?(:created_at)
 
         created = request.created_at
@@ -498,6 +513,14 @@ module Hive
           created_at = parse_time(data["created_at"])
           return :invalid_created_at if created_at.nil?
 
+          expected_marker_id = data["expected_cleared_marker_id"]
+          if !expected_marker_id.nil? &&
+             (!expected_marker_id.is_a?(String) ||
+              !MARKER_ID_RE.match?(expected_marker_id) ||
+              expected_marker_id.to_s.bytesize > 128)
+            return :invalid_expected_cleared_marker_id
+          end
+
           Request.new(
             request_id: request_id,
             created_at: created_at,
@@ -508,6 +531,7 @@ module Hive
             chat_id: data["chat_id"],
             update_id: data["update_id"],
             trigger: data["trigger"].to_s,
+            expected_cleared_marker_id: expected_marker_id,
             path: path
           )
         end
diff --git a/lib/hive/daemon/dispatcher.rb b/lib/hive/daemon/dispatcher.rb
index 1f272c69..560b35d2 100644
--- a/lib/hive/daemon/dispatcher.rb
+++ b/lib/hive/daemon/dispatcher.rb
@@ -5,6 +5,7 @@ require "hive/config"
 require "hive/stages"
 require "hive/workflows"
 require "hive/task_action"
+require "hive/task"
 require "hive/brainstorm_parser"
 require "hive/daemon/policy"
 require "hive/daemon/plan_approval"
@@ -12,6 +13,9 @@ require "hive/daemon/concurrency_controller"
 require "hive/daemon/child_supervisor"
 require "hive/daemon/status_consumer"
 require "hive/daemon/stale_agent_healer"
+require "hive/daemon/auto_retry"
+require "hive/daemon/auto_retry_policy"
+require "hive/daemon/auto_retry_probe"
 require "hive/daemon/display_name_backfiller"
 require "hive/daemon/task_id_backfiller"
 require "hive/daemon/dispatch_request_queue"
@@ -22,6 +26,7 @@ require "hive/daemon/answer_digest_scheduler"
 require "hive/daemon/patrol_scheduler"
 require "hive/daemon/pr_merge_watcher"
 require "hive/lock"
+require "hive/markers"
 require "hive/paths"
 require "hive/update_check"
 require "hive/update_check/state"
@@ -60,7 +65,8 @@ module Hive
                      merge_watcher: nil, patrol_scheduler: nil, digest_scheduler: nil,
                      answer_digest_scheduler: nil, dry_run: false,
                      update_state: nil, update_checker: nil, channel_detector: nil,
-                     dispatch_request_state_home: nil, dispatch_result_state_home: nil)
+                     dispatch_request_state_home: nil, dispatch_result_state_home: nil,
+                     auto_retry: nil, auto_retry_factory: nil)
         @config = config
         @controller = controller
         @supervisor = supervisor
@@ -167,6 +173,13 @@ module Hive
         # resolves the result home independently) never reads them (#251).
         @dispatch_request_state_home = dispatch_request_state_home
         @dispatch_result_state_home = dispatch_result_state_home
+        @auto_retry_factory = auto_retry_factory || -> { build_auto_retry }
+        @auto_retry_injected = !auto_retry.nil? && auto_retry_factory.nil?
+        @auto_retry = auto_retry || @auto_retry_factory.call
+        # Capture the loaded source identity at daemon construction, before a
+        # long-running process can observe an in-place install update. Ordinary
+        # short-lived CLI commands leave the expensive manifest hash lazy.
+        Hive::InvokedBinary.loaded_identity
         # `[project, slug] → last-logged error signature` for the
         # brainstorm-gate parse-error log dedup (see
         # `brainstorm_answers_pending?`).
@@ -269,6 +282,12 @@ module Hive
                         keeping_previous: true)
         end
 
+        # Dependency-health recovery owns only its fixed reason allowlist.
+        # It runs after stale marker normalization and before request
+        # consumption so a successful guarded clear can enter the normal
+        # queue path in this same tick.
+        run_auto_retry(result.rows, now: now)
+
         # Self-heal tasks left showing their raw slug because name
         # generation never landed at `hive new`. Purely additive and
         # marker-free, so order relative to dispatch is irrelevant — but
@@ -1337,6 +1356,15 @@ module Hive
           return
         end
 
+        if @legacy_layout_projects.key?(req.project)
+          @logger.event(:dispatch_request_blocked,
+                        request_id: req.request_id, project: req.project,
+                        slug: req.slug, reason: "legacy_layout_detected")
+          return
+        end
+
+        return unless retry_marker_guard_allows?(req)
+
         # Reverse the gate-evaluation order from the previous version:
         # check the cheap, deterministic running_task? gate first so an
         # in-flight slug doesn't incur the can_dispatch? scan. Per R-04
@@ -1380,9 +1408,10 @@ module Hive
         pid = dispatch_command(
           command,
           project: req.project, slug: req.slug,
-          # Request-driven runs don't carry a stage hint — the runner
-          # resolves the task's current stage at boot. Pass nil so the
-          # log line records `stage=nil` instead of inventing one.
+          # The runner resolves the task's current stage at boot. A guarded
+          # retry may carry `--stage` for exact state-file resolution, but
+          # request dispatch still records stage=nil rather than deriving
+          # controller metadata from arbitrary argv.
           stage: nil,
           state_file_mtime: state_file_path && File.exist?(state_file_path) ? File.mtime(state_file_path) : nil,
           state_file_path: state_file_path,
@@ -1623,15 +1652,65 @@ module Hive
 
       # Best-effort lookup of the task's CURRENT state file so the
       # post-completion mtime refresh inside `reap_completed` has a
-      # path to stat. Mirrors `find_post_advance_state_file` but
-      # without the at-dispatch path (a request carries no stage hint).
+      # path to stat. Guarded auto-retry requests carry an exact `--stage`;
+      # ordinary requests retain the newest-state fallback.
       def resolve_request_state_file_path(req)
         project_entry = Hive::Config.find_project(req.project)
         return nil unless project_entry
 
+        expected = req.expected_cleared_marker_id.to_s
+        return resolve_guarded_retry_state_file(project_entry, req) unless expected.empty?
+
         find_post_advance_state_file(project_entry["hive_state_path"], req.slug)
       end
 
+      def resolve_guarded_retry_state_file(project_entry, req)
+        stage_index = req.argv.each_index.find { |index| req.argv[index] == "--stage" }
+        return nil unless stage_index
+
+        stage = req.argv[stage_index + 1].to_s
+        return nil if stage.empty?
+
+        folder = File.join(
+          project_entry["hive_state_path"].to_s,
+          "stages", stage, req.slug.to_s
+        )
+        return nil unless File.directory?(folder)
+
+        Hive::Task.new(folder).state_file
+      rescue Hive::Error, ArgumentError
+        nil
+      end
+
+      def retry_marker_guard_allows?(req)
+        expected = req.expected_cleared_marker_id.to_s
+        return true if expected.empty?
+
+        state_file = resolve_request_state_file_path(req)
+        unless state_file && File.file?(state_file)
+          reject_request(req, reason: "marker_guard_state_unavailable")
+          return false
+        end
+
+        marker = Hive::Markers.current(state_file)
+        return true if marker.name == :none
+
+        if marker.name == :error && marker.attrs["marker_id"].to_s == expected
+          @logger.event(
+            :dispatch_request_blocked,
+            request_id: req.request_id, project: req.project,
+            slug: req.slug, reason: "marker_not_cleared"
+          )
+          return false
+        end
+
+        reject_request(req, reason: "marker_guard_mismatch")
+        false
+      rescue SystemCallError, IOError
+        reject_request(req, reason: "marker_guard_state_unavailable")
+        false
+      end
+
       def dispatch_request_state_home
         @dispatch_request_state_home || Hive::Paths.state_home
       end
@@ -1770,6 +1849,49 @@ module Hive
         @enabled_cache[project_name] = false
       end
 
+      def run_auto_retry(rows, now:)
+        return unless @daemon_cfg.dig("auto_retry", "enabled") != false
+
+        eligible_rows = Array(rows).select do |row|
+          project_enabled?(row.project) &&
+            !@legacy_layout_projects.key?(row.project)
+        end
+        @auto_retry.tick(eligible_rows, now: now)
+      rescue StandardError => e
+        @logger.event(
+          :auto_retry_error,
+          action: "coordinator_error",
+          rationale: "#{e.class}: #{e.message}",
+          timestamp: now.utc.iso8601(6)
+        )
+      end
+
+      def build_auto_retry
+        AutoRetry.new(
+          policy: AutoRetryPolicy.new,
+          probe_factory: lambda { |row, _decision|
+            entry = Hive::Config.find_project(row.project)
+            raise Hive::ConfigError, "project #{row.project.inspect} is not registered" unless entry
+
+            root = entry["path"]
+            AutoRetryProbe.new(
+              config: Hive::Config.load(root),
+              project_root: root
+            )
+          },
+          state_home: dispatch_request_state_home,
+          dry_run: @dry_run,
+          audit: method(:audit_auto_retry)
+        )
+      end
+
+      def audit_auto_retry(transition:, **attrs)
+        @logger.event(
+          transition ? :auto_retry_action : :auto_retry_decision,
+          **attrs
+        )
+      end
+
       def reload_config!
         # PR-40 review P1 #2: rebase on the global ~/Dev/hive/config.yml's
         # daemon block, not bare DEFAULTS.
@@ -1842,6 +1964,7 @@ module Hive
           logger: @logger,
           dry_run: @dry_run
         )
+        @auto_retry = @auto_retry_factory.call unless @auto_retry_injected
         @enabled_cache.clear
         @logger.event(:config_reloaded)
       rescue Hive::ConfigError => e
